/*
    QAD - Qt ADvanced

    Ivan Pelipenko peri4ko@yandex.ru, Andrey Bychkov work.a.b@yandex.ru

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef MATH_VECTOR_EDIT_H
#define MATH_VECTOR_EDIT_H

#include "qad_widgets_export.h"

#include <QVariant>
#include <QWidget>


class MatrixEdit;


class QAD_WIDGETS_EXPORT MathVectorEdit: public QWidget {
	Q_OBJECT
	Q_PROPERTY(QVariant value READ value WRITE setValue NOTIFY valueChanged)
	Q_PROPERTY(bool readOnly READ isReadOnly WRITE setReadOnly)

public:
	explicit MathVectorEdit(QWidget * parent = nullptr);
	~MathVectorEdit() override;

	QVariant value() const;
	bool isReadOnly() const;

public slots:
	void setValue(const QVariant & v);
	void setReadOnly(bool yes);

signals:
	void valueChanged();

private:
	MatrixEdit * edit;
};


class QAD_WIDGETS_EXPORT __MathVectorEditRegistrator__ {
public:
	__MathVectorEditRegistrator__();
};

static __MathVectorEditRegistrator__ __mathvectoreditregistrator__;

#endif // MATH_VECTOR_EDIT_H
